package com.starry.admin.modules.clerk.controller;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.starry.admin.modules.clerk.module.entity.PlayClerkCommodityEntity;
import com.starry.admin.modules.clerk.module.vo.PlayClerkCommodityQueryVo;
import com.starry.admin.modules.clerk.service.IPlayClerkCommodityService;
import com.starry.common.annotation.Log;
import com.starry.common.enums.BusinessType;
import com.starry.common.result.R;
import com.starry.common.utils.ConvertUtil;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 陪聊服务项目Controller
 *
 * @author admin
 * @since 2024-03-31
 */
@RestController
@RequestMapping("/clerk/commodity")
public class PlayClerkCommodityController {
    @Resource
    private IPlayClerkCommodityService playClerkCommodityService;

    /**
     * 查询陪聊服务项目列表
     */
    @GetMapping("/listAllCommodity")
    public R listAllCommodity() {
        List<PlayClerkCommodityEntity> list = playClerkCommodityService.selectAll();
        return R.ok(ConvertUtil.entityToVoList(list, PlayClerkCommodityQueryVo.class));
    }


    /**
     * 查询陪聊服务项目列表
     */
    @GetMapping("/list")
    public R list(PlayClerkCommodityEntity playClerkCommodity) {
        IPage<PlayClerkCommodityEntity> list = playClerkCommodityService.selectPlayClerkCommodityByPage(playClerkCommodity);
        return R.ok(list);
    }

    /**
     * 获取陪聊服务项目详细信息
     */
    @GetMapping(value = "/{id}")
    public R getInfo(@PathVariable("id") String id) {
        return R.ok(playClerkCommodityService.selectPlayClerkCommodityById(id));
    }

    /**
     * 新增陪聊服务项目
     */
    @Log(title = "陪聊服务项目", businessType = BusinessType.INSERT)
    @PostMapping("/create")
    public R create(@RequestBody PlayClerkCommodityEntity playClerkCommodity) {
        boolean success = playClerkCommodityService.create(playClerkCommodity);
        if (success) {
            return R.ok();
        }
        return R.error("添加失败");
    }


    /**
     * 修改陪聊服务项目
     */
    @Log(title = "陪聊服务项目", businessType = BusinessType.UPDATE)
    @PostMapping(value = "/update/{id}")
    public R update(@PathVariable String id, @RequestBody PlayClerkCommodityEntity playClerkCommodity) {
        playClerkCommodity.setId(id);
        boolean success = playClerkCommodityService.update(playClerkCommodity);
        if (success) {
            return R.ok();
        }
        return R.error("修改失败");
    }

    /**
     * 删除陪聊服务项目
     */
    @Log(title = "陪聊服务项目", businessType = BusinessType.DELETE)
    @DeleteMapping("/{ids}")
    public R remove(@PathVariable String[] ids) {
        return R.ok(playClerkCommodityService.deletePlayClerkCommodityByIds(ids));
    }
}
